#include <iostream>

using namespace std;
int n,a,b,c,d;
int kolona [100000];
int vrsta [100000];
int main()
{
    cin>>n;
    if(n==1)
        cout<<0;
    if(n==2)
    {
        cin>>a>>b>>c>>d;
        if((a==b && c==d)||(a!=b && c!=d))
            cout<<0;
        else
            cout<<1;
    }
    else
    {
        for(int i=0;i<n;i++)
        {
            kolona[i]=0;
            vrsta[i]=0;
        }
         for(int i=0;i<n;i++)
         {
            cin>>a>>b;
            vrsta[a]++;
            kolona[b]++;
         }
         int f=0;
         for(int i=1;i<n;i++)
        {
            if(kolona[i]!=1 || vrsta[i]!=1)
                f=1;
        }
        if(f==0)
            cout<<0;
    }

}